# Python, Thread, Schedule et parallelisme

![tag](Python)

Nous avons déjà vu sur https://blog.fraoustin.fr/?md=20200503204301 comment paralleliser plusieurs traitements identiques en utilisant des Threads et des Queues.

Mais on peut rencontrer ce problème de thread, parallelisme dans plusieurs situations et parfois il ne faut pas lancer les mêmes actions.

Pour résoudre cela on a plusieurs possibilités

- parallelisme d'une mêm action: Thread Queue
- parallelisme d'action différente: Thread
- action autonome à heure fixe: Schedule
- surveillance de modification de fichier: watchdog

```python
import threading
import time

def todo(value, run_event):
    while run_event.is_set():
        print(value)
		time.sleep(1)


run_event = threading.Event()
run_event.set()
threads = []
threads.append(threading.Thread(target = todo, args = (1,run_event)))
for thread in threads:
	thread.start()
try:
  while 1:
  	time.sleep(.1)
except KeyboardInterrupt:
	logger.info("Boucle interrompue par l'utilisateur")
	logger.info("Attente fin de Threads")
	run_event.clear()
	for thread in threads:
		thread.join()
	logger.info("Threads termines")
```

pour schedule il faut allez voir sur https://schedule.readthedocs.io/ pour trouver de de nombreux exemple.
Attention a la notion de parallèle il faut parfois créer plusieurs scheduler ou des threads


un autre module qui permet de voir ce qui se passe au niveau d'un fichier


```python
from watchdog.observers import Observer
from watchdog.events import FileSystemEventHandler
import time

class MyHandler(FileSystemEventHandler):
    def on_created(self, event):
        print(f"Fichier créé : {event.src_path}")

    def on_modified(self, event):
        print(f"Fichier modifié : {event.src_path}")

    def on_deleted(self, event):
        print(f"Fichier supprimé : {event.src_path}")

path = "chemin/vers/le/repertoire"
event_handler = MyHandler()
observer = Observer()
observer.schedule(event_handler, path, recursive=True)
observer.start()

try:
    while True:
        time.sleep(1)
except KeyboardInterrupt:
    observer.stop()
observer.join()
```

